.IFDEF INITIALIZE_MMS

all ::
	@ $(CreateMms) bootstrapDynstub .obj .cc
	@ $(CreateMms) NamingDynstub .obj .cc
	@ $(CreateMms) any .obj .cc
	@ $(CreateMms) typecode .obj .cc
	@ $(CreateMms) anyP .obj .cc
	@ $(CreateMms) tcParser .obj .cc
	@ $(CreateMms) dynAny .obj .cc
	@ $(CreateMms) dynAnyNil .obj .cc
	@ $(CreateMms) namedValue .obj .cc
	@ $(CreateMms) nvList .obj .cc
	@ $(CreateMms) exceptionList .obj .cc
	@ $(CreateMms) contextList .obj .cc
	@ $(CreateMms) environment .obj .cc
	@ $(CreateMms) context .obj .cc
	@ $(CreateMms) deferredRequest .obj .cc
	@ $(CreateMms) unknownUserExn .obj .cc
	@ $(CreateMms) proxycall .obj .cc
	@ $(CreateMms) request .obj .cc
	@ $(CreateMms) serverRequest .obj .cc
	@ $(CreateMms) dynamicImplementation .obj .cc
	@ $(CreateMms) pseudoBase .obj .cc
	@ $(CreateMms) dynException .obj .cc
	@ $(CreateMms) orbMultiRequest .obj .cc
	@ $(CreateMms) corbaidlstub .obj .cc
	@ $(CreateMms) corbaidldynstub .obj .cc
	@ $(CreateMms) ir .obj .cc
	@ $(CreateMms) irstub .obj .cc
	@ $(CreateMms) irdynstub .obj .cc

.ELSE

# Qualifier added for generation of shareable images.  By default (without these
# qualifiers) objects with external linkage (namespace, class or file scope
# objects) do not appear in lib/list/names output (used to parse the symbol
# vector table).

DIR_CPPFLAGS = /Extern_model=strict_refdef/NoShare

CONFIG_DEFAULT_LOCATION = omniCFG:omniORB.cfg

DIR_CPPMACROS = "CONFIG_DEFAULT_LOCATION=""$(CONFIG_DEFAULT_LOCATION)""",\
"USE_omniORB_logStream","_OMNIORB2_DYNAMIC_LIBRARY"

DIR_CPPINCLUDES=[],[-]

dynlib = omniDynamic2$(DebugSuffix).olb

DYN2_OBJS = $(dynlib)(bootstrapdynstub)\
	$(dynlib)(Namingdynstub)\
	$(dynlib)(any)\
	$(dynlib)(typecode)\
	$(dynlib)(anyP)\
	$(dynlib)(tcParser)\
	$(dynlib)(dynAny)\
	$(dynlib)(dynAnyNil)\
	$(dynlib)(namedValue)\
	$(dynlib)(nvList)\
	$(dynlib)(exceptionList)\
	$(dynlib)(contextList)\
	$(dynlib)(environment)\
	$(dynlib)(context)\
	$(dynlib)(deferredRequest)\
	$(dynlib)(unknownUserExn)\
	$(dynlib)(proxycall)\
	$(dynlib)(request)\
	$(dynlib)(serverRequest)\
	$(dynlib)(dynamicImplementation)\
	$(dynlib)(pseudoBase)\
	$(dynlib)(dynException)\
	$(dynlib)(ir)\
	$(dynlib)(irstub)\
	$(dynlib)(irdynstub)\
	$(dynlib)(corbaidlstub)\
	$(dynlib)(corbaidldynstub)

.first
	@ $(FirstActions)
	@ omniorb2_device=f$parse("[-]",,,"device")
	@ omniorb2_directory=f$parse("[-]",,,"directory")
	@ define/nolog omniorb2 -
		'omniorb2_device''omniorb2_directory','f$trnlnm("omniorb2")

SUBDIRS = sharedlib

all :: $(DYN2_OBJS)
.IFDEF CXX6
	@ $(MakeSubDirs)
.ENDIF

.include bootstrapdynstub.mms
.include Namingdynstub.mms
.include any.mms
.include typecode.mms
.include anyP.mms
.include tcParser.mms
.include dynAny.mms
.include dynAnyNil.mms
.include namedValue.mms
.include nvList.mms
.include exceptionList.mms
.include contextList.mms
.include environment.mms
.include context.mms
.include deferredRequest.mms
.include unknownUserExn.mms
.include proxycall.mms
.include request.mms
.include serverRequest.mms
.include dynamicImplementation.mms
.include pseudoBase.mms
.include dynException.mms
.include orbMultiRequest.mms
.include ir.mms
.include irstub.mms
.include irdynstub.mms
.include corbaidlstub.mms
.include corbaidldynstub.mms

export :: $(DYN2_OBJS)

export :: $(dynlib)
	@ $(ExportLibrary)
.IFDEF CXX6
	@ $(MakeSubDirs)
.ENDIF

.ENDIF
